﻿#!/usr/bin/perl -w
# このプログラムは，Sequence がない OTU に Gap 配列を加えます．
# 例えば，遺伝子ごとに OTU 数が異なる場合に，
# ある遺伝子で配列が無い OTU に他の OTU と同じ配列数の
# Gap を加えます．

use strict;
use warnings;

my $SpListFile = "SpList";
my $InfileFol = "Infile_fol";
# my $OutPutFile = "Concatenated.txt";
my $gap = "";
my $name = "";
my $seq = "";
my $SpKeys = "";
my $addname = "";
my $SeqLength = 0;
my $FileMilestone = 0;
my $LineMilestone = 0;
my @SpListArray = ( );
my @InFiles = ( );
my @inFileCont = ( );
my %efas = ( );

my $OutFolder = "Outfile_fol";

# Output folder is made.
if (-d "$OutFolder") {
system ("rm -r $OutFolder");
}
if (!-d "$OutFolder") {
mkdir("$OutFolder", 0755);
}

# $SpListFile を読んで配列に入れる．
open(SPLIST,"$SpListFile");
@SpListArray = <SPLIST>;
close SPLIST;
#foreach my $spname (@SpListArray) {
#  print "$spname";
#}


# 各ファイルからファスタ形式を取り込んでハッシュに格納する．
opendir(DIR,"$InfileFol");
@InFiles = readdir(DIR);
close(DIR);
# print "@InFiles";

foreach my $inFileName (@InFiles) {
  if ($inFileName !~ /^\./) {
#   print OUT "\n\n########## $inFileName ########## ";
    open(INFILE,"$InfileFol/$inFileName");
    @inFileCont = <INFILE>;
    close INFILE;

    foreach my $line (@inFileCont) {
      if ($line =~ /^>/) {
        if ($LineMilestone == 0) {
          chomp($line);
          $name = $line;
          $LineMilestone = 1;      
        } else {
          $name =~ s/>//g;
          $efas{$name} = $seq;
          $name = '';
          $seq = '';
          chomp($line);
          $name = $line;    
        }
      } else {
        chomp($line);
        $seq .= $line;
      }
    }
    $name =~ s/>//g;
    $efas{$name} = $seq;
    $SeqLength = length($seq);
    $name = '';
    $seq = '';

    # infile に無かった種のハッシュ要素に配列と同じ長さのダッシュをくわえる．
    for (my $i = 0; $i < scalar@SpListArray; $i++) {
      chomp($SpListArray[$i]);
      if (grep /^>$SpListArray[$i]/,@inFileCont) {
        next;
      } else {
        $addname = $SpListArray[$i];
        for (my $k=0 ; $k < $SeqLength; $k++) {
          $gap .= "-";
        }
        $efas{$addname} .= $gap;
        $gap = '';
      }
    }
    $LineMilestone = 0;

#    print OUT "\n";
#    print OUT "\nJust shows efas\n";
#    print OUT "\%efas contents\n";
#    print OUT "SeqLength: $SeqLength\n";
#    foreach my $pname (keys %efas) {
#      print OUT "Key: $pname\n$efas{$pname}\n";
#    }

#    %efas = ();   
     
    #プリントアウト
    open (OUT,">$OutFolder/$inFileName");
    foreach my $pname (@SpListArray) {
      print OUT ">$pname\n$efas{$pname}\n";
    }
    close OUT;
    
    %efas = ();
  
  }
}
exit;